<template>
  <div id="map">
    <div id="popup-map">
      <slot name="popup"> default content of the popup </slot>
    </div>
  </div>
</template>

<script>
import L from "leaflet";
import "leaflet/dist/leaflet.css";

let map;

export default {
  props: {
    coordinates: {
      type: Array,
      default: () => [],
    },
    currentCoordinate: {
      type: Object,
    },
    modelValue: {
      type: Object,
    },
    jsonData: {
      type: Object,
    },
  },
  emits: ["update:modelValue"],
  methods: {
    addCoordinates(coordinates) {
      if (!map) return; // si la carte n'a pas encore été définie, on ne peut rien faire
      coordinates.forEach((value) => {
        L.marker(value.geometry.coordinates)
          .addTo(map)
          .bindPopup(value.properties.label);
      });
    },
    panToCoordinate(coord) {
      if (!map) return; // si la carte n'a pas encore été définie, on ne peut rien faire
      map.panTo(coord.geometry.coordinates);
    },
    emitBBox(bbox) {
      this.$emit("update:modelValue", bbox);
    },
    displayGeoJSON() {
      if (this.geojson instanceof L.GeoJSON) {
        this.geojson.removeFrom(map);
      }
      this.geojson = L.geoJSON(this.jsonData).addTo(map);
    },
  },
  mounted() {
    map = L.map("map").setView([51.505, -0.09], 13);

    L.tileLayer("https://tile.openstreetmap.org/{z}/{x}/{y}.png", {
      attribution:
        '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors',
    }).addTo(map);

    map.on("zoomend moveend", () => {
      this.emitBBox(map.getBounds());
    });
    this.emitBBox(map.getBounds());

    if (this.coordinates) this.addCoordinates(this.coordinates);
    if (this.currentCoordinate) this.panToCoordinate(this.currentCoordinate);
  },
  watch: {
    coordinates: "addCoordinates",
    currentCoordinate: "panToCoordinate",
    jsonData: "displayGeoJSON",
    /**
     * Si l'on souhaite réduire le hook `mounted` à l'initialisation de la carte,
     * il serait possible d'écrire également :
     */
    // coordinates: {
    //   immediate: true,
    //   handler(newValue) {
    //     if (!newValue) return;
    //     this.addCoordinates(newValue);
    //   },
    // },
    // currentCoordinate: {
    //   immediate: true,
    //   handler(newValue) {
    //     if (!newValue) return;
    //     this.panToCoordinate(newValue);
    //   },
    // },
  },
};
</script>

<style scoped>
#map {
  height: 360px;
  position: relative;
}
#popup-map {
  z-index: 10000;
  width: 300px;
  border: 1px solid grey;
  position: absolute;
  background-color: white;
  color: black;
  padding: 1rem;
  border-radius: 2px;
  right: 1rem;
  bottom: 1rem;
}
</style>
